/**************************************************************** 
 * Description: C++ 已经前序和中序，输出后序
 * Author: Alex Li
 * Date: 2024-08-18 19:19:09
 * LastEditTime: 2024-08-18 19:19:13
****************************************************************/
#include<iostream>
#include<cstring>
using namespace std;

#define MAX 100 // 定义数组最大长度为100

// 递归函数，构建并输出后序遍历
void solve(char first[], int spos_f, int epos_f, char mid[], int spos_m, int epos_m){
	int i, root_m; // i用于循环，root_m用于记录根节点在中序遍历中的位置
	if(spos_f > epos_f) // 基本条件：如果当前子树为空，直接返回
		return;
    
    // 在中序遍历中找到当前子树的根节点位置
	for(i = spos_m; i <= epos_m; i++)
		if(first[spos_f] == mid[i]){ // 根节点是前序遍历中的第一个元素
			root_m = i; // 记录根节点在中序遍历中的位置
			break;
		}

    // 递归处理左子树
	solve(first, spos_f + 1, spos_f + (root_m - spos_m), mid, spos_m, root_m - 1);
    
    // 递归处理右子树
	solve(first, spos_f + (root_m - spos_m) + 1, epos_f, mid, root_m + 1, epos_m);
    
    // 输出当前子树的根节点（即后序遍历中的最后一个节点）
	cout << first[spos_f];
}

int main(){
	char first[MAX], mid[MAX]; // 定义存储前序和中序遍历的字符数组
	int len; // 定义输入的遍历序列长度
	cin >> len; // 读取长度
	cin >> first >> mid; // 读取前序和中序遍历序列
	solve(first, 0, len - 1, mid , 0, len - 1); // 调用递归函数，构建后序遍历
	cout << endl; // 输出一个换行符
	return 0;
}
